/************************************************************************
*									*
* The SB-Prolog System							*
* Copyright SUNY at Stony Brook, 1986; University of Arizona, 1987	*
*									*
************************************************************************/

/*-----------------------------------------------------------------
SB-Prolog is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the SB-Prolog General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
SB-Prolog, but only under the conditions described in the
SB-Prolog General Public License.   A copy of this license is
supposed to have been given to you along with SB-Prolog so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies. 
------------------------------------------------------------------ */

#include "inst.h"
#include "sim.h"

#define pad pcreg++
#define parse_operand1(y) oprnd1 = (word)*(y *)(pcreg); pcreg = (pb)(pcreg + 1)
#define parse_operand2(y) oprnd2 = (word)*(y *)(pcreg); pcreg = (pb)((y)pcreg + 1)
#define parse_operand3(y) oprnd3 = (word)*(y *)(pcreg); pcreg = (pb)((y)pcreg + 1)


int (*p_routine[16])();

int extra1_oprnd1;
int extra2_oprnd2;
int extra3_oprnd3;


Aprint_it(str,op1,op2,op3)
char *str;
word op1,op2,op3;
{
return;
	printf("%s: ",str);
	if(op1!=NULL)
	   printf("%x ",op1); else printf("1nil ");
	if(op2!=NULL)
	   printf("%x ",op2); else printf("2nil ");
	if(op3!=NULL)
	   printf("%x ",op3); else printf("3nil ");
	printf("\n");
}

p_E()
{ 
quit("error, should not get to p_E in parse_oprnd");
}

p_PBB()
{
    pad;

    parse_operand1(byte);
    extra1_oprnd1 = oprnd1;
    parse_operand1(byte);
    oprnd2 = oprnd1;
    oprnd1 = extra1_oprnd1;
/*    parse_operand2(byte);*/
    Aprint_it("p_PBB",oprnd1,oprnd2,NULL);
}


p_BW()
{
    parse_operand1(byte);
    extra1_oprnd1 = oprnd1;
    parse_operand1(byte);
    oprnd2 = oprnd1;
    oprnd1 = extra1_oprnd1;
/*    parse_operand2(byte);*/
    Aprint_it("p_BW",oprnd1,oprnd2,NULL);
}

p_BC()
{
    parse_operand1(byte);
    parse_operand2(word);
    Aprint_it("p_BC",oprnd1,oprnd2,NULL);
}

p_B()
{
    parse_operand1(byte);
   Aprint_it("p_B",oprnd1,NULL,NULL);
}

p_PW()
{
    pad;
    extra2_oprnd2 = oprnd2;
    parse_operand2(word);
    oprnd1 = oprnd2;
    oprnd2 = extra2_oprnd2;
    /*parse_operand1(word);*/
    Aprint_it("p_PW",oprnd1,NULL,NULL);
}

p_PC()
{
	
    pad;
    extra2_oprnd2 = oprnd2;
    parse_operand2(word);
    oprnd1 = oprnd2;
    oprnd2 = extra2_oprnd2;	
/*    parse_operand1(word);*/
    Aprint_it("p_PC",oprnd1,NULL,NULL);
}

p_PL()
{
    pad;
    extra2_oprnd2 = oprnd2;
    parse_operand2(long);
    oprnd1 = oprnd2;
    oprnd2 = extra2_oprnd2;
    /*parse_operand1(long);*/  
    Aprint_it("p_PL",oprnd1,NULL,NULL);
}

p_BA()
{
    parse_operand1(byte);
    parse_operand2(pw);
   Aprint_it("p_BA",oprnd1,oprnd2,NULL);
}

p_BAA()
{
    parse_operand1(byte);
    parse_operand2(pw);
    parse_operand3(pw);
    Aprint_it("p_BAA",oprnd1,oprnd2,oprnd3);
}

p_PA()
{
        pad;
	extra2_oprnd2 = oprnd2;
	parse_operand2(pw);
	oprnd1 = oprnd2;
	oprnd2 = extra2_oprnd2;
/*    parse_operand1(pw);*/
	Aprint_it("P_PA",oprnd1,NULL,NULL);
}

p_BL()
{
    parse_operand1(byte);
    parse_operand2(long);
    Aprint_it("P_BA",oprnd1,oprnd2,NULL);
}

p_P()
{
    pad;
    Aprint_it("p_P",NULL,NULL,NULL);
}

p_BBB()
{
    parse_operand1(byte);

/*    parse_operand2(byte);*/
	extra1_oprnd1 = oprnd1;
	parse_operand1(byte);
	oprnd2 = oprnd1;
/*    parse_operand3(byte);*/
	parse_operand1(byte);
	oprnd3 = oprnd1;
	oprnd1 = extra1_oprnd1;
        Aprint_it("p_BBB",oprnd1,oprnd2,oprnd3);
}

init_parse_routine()
{
    p_routine[E] = p_E;
    p_routine[PBB] = p_PBB;
    p_routine[BW] = p_BW;
    p_routine[BC] = p_BC;
    p_routine[B] = p_B;
    p_routine[PW] = p_PW;
    p_routine[PC] = p_PC;
    p_routine[PL] = p_PL;
    p_routine[BA] = p_BA;
    p_routine[BAA] = p_BAA;
    p_routine[PA] = p_PA;
    p_routine[BL] = p_BL;
    p_routine[P] = p_P;
    p_routine[BBB] = p_BBB;
}
